﻿//-------------------------------------------------------------------------------------------------
// File : asdxResDDS.h
// Desc : Direct Draw Surface Loader.
// Copyright(c) Project Asura. All right reserved.
//-------------------------------------------------------------------------------------------------
#pragma once

//-------------------------------------------------------------------------------------------------
// Includes
//-------------------------------------------------------------------------------------------------
#include <asdxResTexture.h>


namespace asdx {

//-------------------------------------------------------------------------------------------------
//! @brief      DDSからリソーステクスチャを読込します.
//!
//! @param[in]      filename    ファイル名です.
//! @param[out]     pResult     リソーステクスチャの格納先です
//! @retval true    生成に成功.
//! @retval false   生成に失敗.
//-------------------------------------------------------------------------------------------------
bool LoadResTextureFromDDS( const char16* filename, ResTexture* pResult );

} // namespace asdx
